//------------------------------------------------------------------
#property copyright "copyleft www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  Gray
#property indicator_color2  Lime
#property indicator_color3  Orange
#property indicator_width1  3
#property indicator_width2  3
#property indicator_width3  3
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern string  TimeFrame       = "Current time frame";
extern int     CCIperiod       = 50;
extern int     ATRperiod       = 5;
extern int     applied_price   = 5; 
extern bool    noIntermediate  = true;
extern bool    alertsOn        = false;
extern bool    alertsOnCurrent = true;
extern bool    alertsMessage   = true;
extern bool    alertsSound     = false;
extern bool    alertsEmail     = false;

//
//
//
//
//

double   UpH[];
double   DnH[]; 
double   Trend[];
double   Direction[];

int      timeFrame;
bool     calculateValue;
bool     returnBars;
string   indicatorFileName;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
      SetIndexBuffer(0,Trend); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,UpH);   SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,DnH);   SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexBuffer(3,Direction);
      
         //
         //
         //
         //
         //
                  
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
         
         //
         //
         //
         //
         //

   IndicatorShortName("SuperTrend Histo"+timeFrameToString(timeFrame));    
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
         int limit = MathMax(Bars-counted_bars,Bars-1);
         if (returnBars) { UpH[0] = limit+1; return(0); }
   
   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   {
      for(int i=limit; i >= 0; i--)
      {
         double cciTrend  = iCCI(NULL, 0, CCIperiod, applied_price, i);
         
         //
         //
         //
         //
         //
         
         UpH[i] = EMPTY_VALUE;
         DnH[i] = EMPTY_VALUE;
         Trend[i]     = Trend[i+1];
         Direction[i] = Direction[i+1];
            if (cciTrend > 0) { Trend[i] = 1; Direction[i] =  1; }
            if (cciTrend < 0) { Trend[i] = 1; Direction[i] = -1; }
            if (!noIntermediate)
            {
               if (Direction[i]==-1 && Direction[i+1]==-1) DnH[i] = 1;
               if (Direction[i]== 1 && Direction[i+1]== 1) UpH[i] = 1;
            }
            else
            {
               if (Direction[i] == -1) DnH[i] = 1;
               if (Direction[i] ==  1) UpH[i] = 1;
            }         
      }
      manageAlerts();
      return(0);
   }      

   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      if (!noIntermediate)
      {
         if (Direction[limit] == -1 && Direction[limit+1] == -1) DnH[i] = 1;
         if (Direction[limit] ==  1 && Direction[limit+1] ==  1) UpH[i] = 1;
      }
      else
      {
         if (Direction[limit] == -1) DnH[i] = 1;
         if (Direction[limit] ==  1) UpH[i] = 1;
      }         
   
   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      UpH[i] = EMPTY_VALUE;
      DnH[i] = EMPTY_VALUE;
      Trend[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",CCIperiod,ATRperiod,applied_price,noIntermediate,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,0,y);
      Direction[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",CCIperiod,ATRperiod,applied_price,noIntermediate,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,3,y);
      int pDir     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",CCIperiod,ATRperiod,applied_price,noIntermediate,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,3,y+1);
         if (!noIntermediate)
         {
            if (Direction[i]==-1 && pDir==-1) DnH[i] = 1;
            if (Direction[i]== 1 && pDir== 1) UpH[i] = 1;
         }
         else
         {
            if (Direction[i] == -1) DnH[i] = 1;
            if (Direction[i] ==  1) UpH[i] = 1;
         }         
   }
   return(0);         
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
            int forBar = 0;
      else      forBar = 1;
      
      //
      //
      //
      //
      //
      
      if (noIntermediate)
      {
         if (Direction[forBar]!=Direction[forBar+1])
         {
            if (Direction[forBar]== 1 && Direction[forBar+1]== 1) doAlert(0,"up");
            if (Direction[forBar]==-1 && Direction[forBar+1]==-1) doAlert(0,"down");
         }            
      }
      else
      {
         if (Direction[forBar]==Direction[forBar+1] && Direction[forBar]!=Direction[forBar+2])
         {
            if (Direction[forBar]== 1) doAlert(0,"up");
            if (Direction[forBar]==-1) doAlert(0,"down");
         }            
      }         
   }
} 

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  timeFrameToString(Period())+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" super trend to "+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," super trend"),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}